// drvtst.cpp: implementation of the drvtst class.
//
//////////////////////////////////////////////////////////////////////
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <windows.h>
#include <winioctl.h>
#include "eva16ch.h"
#include "drvtst.h"

#define		TEST_CHAN	0


BYTE	*lpBuffer0;
BYTE	*lpBuffer1;

BYTE	*BufStart;
BYTE	*AdcBufStart;
DWORD	BufferSize;

int dma_running = 0;
int dac_vol = 8;
int dma_buf_length = 0x2000;

int loop_channel = 0;
int adc_vol = 8;
int mon_enable = 1;

int MaxCards;
int cur_card;
//int sample_rate = 8000;
//int  sample_rate = 11025;
int sample_rate = 22050;
//int sample_rate = 44100;
int cur_in_sel = 0;

#define MAX_TEST_CHANNELS	16


class eepst : public eepReport 
{
public :
	eepst() {};
	virtual ~eepst() {};
	virtual void Status(int msg,int par);
};

void eepst::Status(int msg,int par)
{

	switch(msg) {

		case	EEP_ERASE_ALL_START :
			printf("eeprom erase all start\n");
			break;

		case	EEP_ERASE_ALL_ENDED:
			printf("eeprom erase all ended\n");
			break;

		case	EEP_PROG_START:
			printf("\neeprom Program start\n");
			break;

		case	EEP_PROG_SECTOR :
			printf("eeprom Prog Sector = %8lx\r",par);
			break;


		case	EEP_PROG_ENDED :
			printf("\neeprom Program ended\n");
			break;


		case	EEP_VERIFY_START:
			printf("eeprom Verify start\n");
			break;

		case	EEP_VERIFY_ENDED :
			printf("eeprom Verify ended, errors = %d\n",par);
			break;

		case	EEP_LOAD_FILE:
			printf("eeprom File loading...\n");
			break;

		case	EEP_PROG_FILE_OPEN_ERROR :
			printf("eeprom File not found \n");

			break;

		default :
			break;			
	}
}

eepst est;



// local function types
int	main_init(int ac, char *av[]);
void main_run();
void main_end();
void SaveToFile();
void DumpRegister(int card_num,DWORD s,DWORD length);
void DumpMemory(DWORD *s,DWORD length);


void DumpRegister(int card_num,DWORD s,DWORD length)
{
	int lines;
	int i,j;
	DWORD	value;

	lines = length/4;

	for (j=0;j<lines;j++) {
		printf("%8lx:",(DWORD)s);
		for (i=0;i<4;i++) {
			ADDA_ReadReg(card_num,s,&value);
			printf(" %8lx",value);
			s+=4;
		}
		printf("\n");
	}
	if (length - lines*4) {
		printf("%8lx:",(DWORD)s);
		for (i=0;i<4;i++) {
			ADDA_ReadReg(card_num,s,&value);
			printf(" %8lx",value);
			s+=4;
		}
		printf("\n");
	}
}

void DumpMemory(DWORD *s,DWORD length)
{
	int lines;
	int i,j;
	DWORD	value;

	lines = length/4;

	for (j=0;j<lines;j++) {
		printf("%08lx:",(DWORD)s);
		for (i=0;i<4;i++) {
			printf(" %08lx",*s++);
		}
		printf("\n");
	}

	if (length - lines*4) {
		printf("%08lx:",(DWORD)s);
		for (i=0;i<4;i++) {
			printf(" %08lx",*s++);
		}
		printf("\n");
	}
}


void ClrMem()
{
	int i;
	WORD *s;
	s = (WORD *)BufStart;
	BufferSize = 0x100000;


	for (i=0;i<(BufferSize>>1);i++) {
		*s++ = (i<<4);
	}
}


void VerifyChan0Data()
{
	int i;
	WORD *s;
	int errors;

	s = (WORD *)AdcBufStart;
	BufferSize = 0x100000;



	errors = 0;

	for (i=0;i<(dma_buf_length>>1);i++) {
		if (*s & 0xf000) errors++;
		s++;
	}
	if (errors) {
		printf("Error found = %d\n",errors);
	}
	else {
		printf("Channel 0 data OK\n");
	}
}


void DmaStart(int card_num)
{
	DWORD pos;

	WORD *s;
	int i;
	//int sample_rate = 44100;
	//int sample_rate = 22050;
	//int sample_rate = 11025;
	//int sample_rate = 8000;

	DWORD data;
	ADDA_DmaDacVol(card_num,0,dac_vol);
	for (i=0;i<MAX_TEST_CHANNELS;i++) {
		ADDA_DmaAdcStart(card_num,i,dma_buf_length,sample_rate);
	}
	printf("press any key to quit the position event loop \n");

	BYTE *d0 = lpBuffer0;
	BYTE *d1 = lpBuffer1;
	DWORD size = 0;

	ADDA_MonitorMode(card_num,FALSE);
	loop_channel = 0;
	ADDA_GetDacBuf(card_num,0,&BufStart);
	s = (WORD *)BufStart;
	for (i=0;i<dma_buf_length/2;i++) {
		*s++ = 0;
	}

	ADDA_GetAdcBuf(card_num,loop_channel,&AdcBufStart);
	printf("Loop channel = %d\n",loop_channel);

	
	while (0) {
		ADDA_GetDmaAdcPosOvl(card_num,loop_channel,&pos);
		memcpy(BufStart+(pos-1)*dma_buf_length/2,AdcBufStart+(pos-1)*dma_buf_length/2,dma_buf_length/2);
		memcpy(d0,AdcBufStart+(pos-1)*dma_buf_length/2,dma_buf_length/2);
		d0 += dma_buf_length/2;
		size += dma_buf_length/2;
		if (size>=BufferSize) break;
		printf("Pos = %d\n",pos);
		if (kbhit()) break;
	}
	if (kbhit()) getch();
}



void DmaDacStart(int card_num)
{
	DWORD pos;

	WORD *s;
	int i;
	//int sample_rate = 44100;
	//int sample_rate = 22050;
	//int sample_rate = 8000;

	DWORD data;

	ADDA_DmaDacVol(card_num,0,dac_vol);

	for (i=0;i<1;i++) {
		ADDA_DmaDacStart(card_num,i,dma_buf_length,sample_rate);
	}

	printf("press any key to quit the position event loop \n");

	BYTE *d0 = lpBuffer0;
	BYTE *d1 = lpBuffer1;
	DWORD size = 0;

	loop_channel = 0;
	ADDA_GetDacBuf(card_num,0,&BufStart);
	s = (WORD *)BufStart;
	for (i=0;i<dma_buf_length/2;i++) {
		*s++ = 0;
	}

	ADDA_GetAdcBuf(card_num,loop_channel,&AdcBufStart);
	printf("Loop channel = %d\n",loop_channel);

	while (0) {

		ADDA_GetDmaDacPosOvl(card_num,0,&pos);
		memcpy(BufStart+(pos-1)*dma_buf_length/2,AdcBufStart+(pos-1)*dma_buf_length/2,dma_buf_length/2);
		memcpy(d0,AdcBufStart+(pos-1)*dma_buf_length/2,dma_buf_length/2);
		d0 += dma_buf_length/2;
		size += dma_buf_length/2;
		if (size>=BufferSize) break;
		printf("Pos = %d\n",pos);
		if (kbhit()) break;
	}
	if (kbhit()) getch();
}





void DmaStop(int card_num)
{
	for (int i=0;i<16;i++) {
		ADDA_DmaAdcStop(card_num,i);
	}
}


void DmaDacStop(int card_num)
{
	for (int i=0;i<1;i++) {
		ADDA_DmaDacStop(card_num,i);
	}
}




void MonStart(int card_num)
{
	DWORD pos;

	WORD *s;
	int i;
	ADDA_MonitorMode(card_num,TRUE);
	ADDA_DmaDacVol(card_num,0,dac_vol);
}


void MonStop(int card_num)
{
	int i;
	ADDA_MonitorMode(card_num,FALSE);
}


void SaveToFile()
{
	FILE *fp;
	int i;
	fp = fopen("data0.raw","wb");
	fwrite((void *)lpBuffer0,4, BufferSize>>2,fp);		// 8bit
	fclose(fp);

	fp = fopen("data1.raw","wb");
	fwrite((void *)lpBuffer1,4, BufferSize>>2,fp);		// 8bit
	fclose(fp);
}


int	main_init(int ac, char *av[])
{
	DWORD	dwErrorCode;
	int	ret = 0;


	BufferSize = 0x100000;
	lpBuffer0 = (BYTE *)malloc(BufferSize);
	lpBuffer1 = (BYTE *)malloc(BufferSize);


	if (ADDA_Init()) {
		printf("Card not installed \n");
		ret = 1;
		return ret;
	}

	MaxCards= ADDA_GetMaxCards();

	// allocate the user buffer
	printf("Main Init,  card numbers = %d\n",ADDA_GetMaxCards());
	for (int i=0;i<MaxCards;i++) ADDA_SetRpt(i,&est);

	dma_running = 0;
	cur_card = 0;
	return ret;
}


void main_end()
{
	ADDA_End();
	free(lpBuffer0);
	free(lpBuffer1);
}


void main_run()
{
	char cmd;
	DWORD data = 0xaaaa5555;
	DWORD data1,data2;
	DWORD pos;
	int i;

	printf("\n\nsa)ve to file, dma_c)apture, dma_st)op, g)et_Info, q)uit :");

	do {

		if (dma_running) {
			ADDA_GetDmaAdcPosOvl(cur_card,loop_channel,&pos);
			memcpy(BufStart+(pos-1)*dma_buf_length/2,AdcBufStart+(pos-1)*dma_buf_length/2,dma_buf_length/2);
			printf("dump peak \n");
			DumpRegister(cur_card,0x880,16);

			if (loop_channel==0) {
				VerifyChan0Data();
			}

		}

		if (_kbhit()) {

			cmd = _getch();

			printf("\n");

			switch (cmd) {

				case '2' : // DMA test
					printf("DMA transfer test\n");
					DmaStart(cur_card);
					dma_running = 1;
					break;

				case '3' : // DMA stop
					printf("DMA stop\n");
					DmaStop(cur_card);
					dma_running = 0;
					break;

				case '4' : // DMA dac start
					DmaDacStart(cur_card);
					break;


				case '5' : // DMA dac stop
					DmaDacStop(cur_card);
					break;

				case '+' :
					if (dac_vol>0) dac_vol--;
					ADDA_DmaDacVol(cur_card,0,dac_vol);
					ADDA_MonitorVol(cur_card,loop_channel,dac_vol);
					printf("Current Volume = %8lx\n",dac_vol);
					Sleep(100);
					break;

				case '-' :
					if (dac_vol<31) dac_vol++;
					ADDA_MonitorVol(0,loop_channel,dac_vol);
					ADDA_DmaDacVol(cur_card,0,dac_vol);
					printf("Current Volume = %8lx\n",dac_vol);
					Sleep(100);
					break;

				case 'n' : // capture channel next

					if (loop_channel<MAX_TEST_CHANNELS-1) {
						loop_channel ++;
					}
					else
						loop_channel = 0;

					ADDA_MonitorVol(cur_card,loop_channel,dac_vol);
					ADDA_GetAdcBuf(cur_card,loop_channel,&AdcBufStart);
					printf("Cur Monitor channel = %d\n",loop_channel);
					break;

				case 'm' : // mon start
					if (mon_enable) {
						mon_enable = 0;
						MonStop(cur_card);
					}
					else {
						mon_enable = 1;
						MonStart(cur_card);
					}
					break;

				case '\\' : // input volume
					if (adc_vol<31) adc_vol++;
					else adc_vol=0;
					printf("Adc vol = %d\n",adc_vol);
					ADDA_DmaAdcVol(cur_card,loop_channel,adc_vol);
					break;


				case 'a' : // save buffer to file
					printf("Save buffer contents to file\n");
					SaveToFile();
					break;

				case 'v' : // view the registers
					printf("View the I/O rigisters, card numbers = %d\n",ADDA_GetMaxCards());
					{
						DumpRegister(cur_card,0x400,0x40);
					}
					break;

				case 'f' : // flush memory
					printf("flush image buffer\n");
					ClrMem();
					break;

				case 'd' : // dump heap memory
					printf("Dump heap memory\n");
					//ADDA_GetAdcBuf(0,0,&BufStart);
					printf("Start = %8lx\n",AdcBufStart);
					DumpMemory((DWORD *)AdcBufStart,64);
					//DumpMemory((DWORD *)(BufStart+0x10000*16),64);
					break;



				case 'c' : // change the current card number

					DmaStop(cur_card);
					dma_running = 0;

					cur_card++;
					if (cur_card==MaxCards) cur_card = 0;
					printf("Current card number = %d\n",cur_card);
					break;


				case '9' : // change Input line in or mic in

					if (cur_in_sel==0)	cur_in_sel = 0xffff;
					else				cur_in_sel = 0;

					ADDA_SetInputMicOrLine(cur_card,cur_in_sel);
					printf("Current input selection = %8lx\n",cur_in_sel);
					Sleep(100);
					break;


/*
				case 'p' : //

					{ int i;

						for (i=0;i<MaxCards;i++) {
							printf("eeprom program card = %d\n",i);
							if (ADDA_Prog(i,"adio_top.mcs")) {
								printf("Program error!!!! restart \n");
								if (ADDA_Prog(i,"adio_top.mcs")) {
									printf("Program error!!!! restart \n");
									if (ADDA_Prog(i,"adio_top.mcs")) {
										printf("Program error!!!!\n");
									}
									else {
										printf("Program OK\n");
									}
								}
								else {
									printf("Program OK\n");
								}
							}
							else {
								printf("Program OK\n");
							}
						}
					}
					break;
				
*/



				case 'q' :	// QUIT
					break;

				default :
					printf("Not supported command \n");
			}
			printf("\n\nsa)ve to file, dma_c)apture, dma_st)op, g)et_Info, q)uit :");
		}

	} while (cmd!='q');
}


void main(int ac, char *av[])
{
	if (!main_init(ac, av) ) {
		main_run();
		main_end();
	}
}
