
#ifndef __EVA16CH_LIB_H_____
#define __EVA16CH_LIB_H_____

#ifdef __cplusplus
extern "C" {
#endif

#define	BYTE	unsigned char
#define WORD	unsigned short
#define DWORD	unsigned long

__declspec( dllexport ) int ADDA_Init();
__declspec( dllexport ) int ADDA_End();


__declspec( dllexport ) int ADDA_GetMaxCards();
__declspec( dllexport ) int ADDA_GetMaxChannels(int card_num);

__declspec( dllexport ) int ADDA_WriteReg(int card_num,DWORD offset,DWORD data);
__declspec( dllexport ) int ADDA_ReadReg(int card_num,DWORD offset,DWORD *data);


// DAC 16 channel, ADC 16 channel parameter meaning
__declspec( dllexport ) int ADDA_GetDacBuf(int card_num,int channel,BYTE **Buf);
__declspec( dllexport ) int ADDA_DmaDacStart(int card_num,int channel,DWORD length,int sample_rate);
__declspec( dllexport ) int ADDA_DmaDacVol(int card_num,int channel,int volume);
__declspec( dllexport ) int ADDA_DmaDacStop(int card_num,int channel);
__declspec( dllexport ) int ADDA_GetDmaDacPosOvl(int card_num,int channel,DWORD *pos);
__declspec( dllexport ) int ADDA_CancelGetDmaDacPos(int card_num,int channel);

// ADC 16 channel
__declspec( dllexport ) int ADDA_GetAdcBuf(int card_num,int channel,BYTE **Buf);
__declspec( dllexport ) int ADDA_DmaAdcStart(int card_num,int channel,DWORD length,int sample_rate);	// length is DMA block length
__declspec( dllexport ) int ADDA_DmaAdcVol(int card_num,int channel,int volume);
__declspec( dllexport ) int ADDA_DmaAdcStop(int card_num,int channel);
__declspec( dllexport ) int ADDA_GetDmaAdcPosOvl(int card_num,int channel,DWORD *pos);
__declspec( dllexport ) int ADDA_CancelGetDmaAdcPos(int card_num,int channel);

__declspec( dllexport ) int ADDA_AdcStart(int card_num,int channel,int sample_rate);	
__declspec( dllexport ) int ADDA_AdcStop(int card_num,int channel);

__declspec( dllexport ) int ADDA_MonitorVol(int card_num,int channel,int volume);
__declspec( dllexport ) int ADDA_MonitorMode(int card_num,int enable);
__declspec( dllexport ) int ADDA_GetAdcPeak(int card_num,int channel,DWORD *data);

__declspec( dllexport ) int ADDA_SetInputMicOrLine(int cur_card, DWORD in_sel);
__declspec( dllexport ) int ADDA_GetInputMicOrLine(int cur_card, DWORD *in_sel);


// eeprom program 
__declspec( dllexport ) void ADDA_SetRpt(int card_num,eepReport *report);
__declspec( dllexport ) int ADDA_Prog(int card_num,char *filename);

#ifdef __cplusplus
}
#endif

#endif
